<template>
  <div
    style="max-width: 56rem; margin: 0 auto; padding-bottom: 3rem"
    class="column items-center q-mt-xs"
  >
    <h1
      v-if="!userID"
      style="width: 100%"
      class="text-h4 q-px-lg text-green-10 text-bold"
    >
      Register Now!
    </h1>

    <h1
      v-else
      style="width: 100%"
      class="text-h4 q-px-lg text-green-10 text-bold"
    >
      Update User Profile
    </h1>
    <q-form
      ref="form"
      autofocus
      style="max-width: 56rem"
      class="row q-px-lg q-gutter-x-sm"
      @submit.prevent="!userID ? addUser() : updateUser()"
    >
      <div class="col-12">
        <h1 class="text-h6 text-green-9">Personal and Contact Details</h1>

        <div class="row q-gutter-xs">
          <q-input
            class="col-12 col-md-4"
            outlined
            dense
            v-model="name"
            label="Name"
            lazy-rules
            :rules="[(val) => !!val || 'Name must be provided']"
          />

          <q-input
            class="col-12 col-md-4"
            outlined
            dense
            v-model="username"
            label="Username"
            lazy-rules
            :rules="[(val) => !!val || 'Username must be provided']"
          />
          <q-input
            class="col-12 col-md-3"
            outlined
            dense
            v-model="email"
            label="Email"
            type="email"
            hint="user@gmail.com"
            reactive-rules
            :rules="[
              (val) =>
                (!!val && String(val).match(/^\D{1,}\@gmail\.com$/)) ||
                'Invalid email address',
            ]"
          />
          <q-input
            class="col-12 col-md-5"
            outlined
            dense
            v-model="phoneNumber"
            label="Phone Number"
            reactive-rules
            type="tel"
            :rules="[
              (val) =>
                (!!val && String(val).match(/^09\d{9}$/)) ||
                'Please provide a valid phone number. The valid format is starts with 09 followed by 9 digits',
            ]"
          />
          <q-input
            class="col-12 col-md-6"
            outlined
            dense
            v-model="website"
            label="Website"
            reactive-rules
            :rules="[
              (val) =>
                (!!val && String(val).match(/^\D{1,}\.{1}pixel8$/)) ||
                'Please provide a valid website. Website must be end with .pixel8',
            ]"
          />
        </div>
      </div>

      <div class="col-12">
        <h1 class="text-h6 text-green-9">Address</h1>
        <div class="row q-gutter-xs">
          <q-input
            class="col-12 col-md-6"
            outlined
            dense
            v-model="street"
            label="Street"
            lazy-rules
            :rules="[(val) => !!val || 'Please provide street name']"
          />
          <q-input
            class="col-12 col-md-5"
            outlined
            dense
            v-model="suite"
            label="Suite"
            lazy-rules
            :rules="[(val) => !!val || 'Please provide suite address']"
          />
          <q-input
            class="col-12 col-md-6"
            outlined
            dense
            v-model="city"
            label="City"
            lazy-rules
            :rules="[(val) => !!val || 'Please provide city name']"
          />
          <q-input
            class="col-12 col-md-5"
            outlined
            dense
            v-model="zipCode"
            label="ZIP Code"
            lazy-rules
            :rules="[(val) => !!val || 'Please provide the ZIP Code']"
          />
        </div>
      </div>

      <div class="col-12" style="width: 100%">
        <h1 class="text-h6 text-green-9">Company</h1>

        <div class="row q-gutter-sm">
          <q-input
            class="col-12 col-md-11"
            outlined
            dense
            v-model="companyName"
            label="Company Name"
            lazy-rules
            :rules="[(val) => !!val || 'Please provide company name']"
          />
          <q-input
            class="col-12 col-md-5"
            outlined
            dense
            v-model="catchPhrase"
            label="Catch Phrase"
            lazy-rules
            :rules="[(val) => !!val || 'Please provide company catch phrase']"
          />
          <q-input
            class="col-12 col-md-6"
            outlined
            dense
            v-model="baseService"
            label="Base Services"
            lazy-rules
            :rules="[(val) => !!val || 'Please provide company services']"
          />
        </div>
      </div>

      <q-btn
        :loading="isAddBtnLoading"
        type="submit"
        class="col-5 q-mt-lg btn--add"
        :label="!userID ? 'Add' : 'Update'"
      />

      <q-btn
        v-if="userID"
        type="submit"
        flat
        class="col-2 q-mt-lg"
        label="Cancel"
        :disable="isAddBtnLoading"
        to="/"
      />
    </q-form>
  </div>

  <q-dialog v-model="dialog">
    <q-card class="q-card">
      <q-card-section>
        <div v-if="!updateModal" class="text-h4 modal--title">
          Successfully Added!
        </div>
        <div v-else class="text-h4 modal--title">Successfully Updated!</div>
      </q-card-section>

      <q-card-section class="q-pt-none">
        <p v-if="!updateModal" class="text-h6">
          User successfully added! You can view it on list of users.
        </p>
        <p v-else class="text-h6">
          User successfully updated! You can view it on list of users.
        </p>
      </q-card-section>

      <q-card-actions align="right">
        <q-btn flat label="OK" color="primary" v-close-popup />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script>
import {
  name,
  username,
  email,
  phoneNumber,
  website,
  street,
  suite,
  city,
  zipCode,
  companyName,
  catchPhrase,
  baseService,
  addUser,
  isAddBtnLoading,
  dialog,
  form,
  userID,
  updateUser,
  updateModal,
} from "../composables/users";

export default {
  setup() {
    return {
      name,
      username,
      email,
      phoneNumber,
      website,
      street,
      suite,
      city,
      zipCode,
      companyName,
      catchPhrase,
      baseService,
      addUser,
      isAddBtnLoading,
      dialog,
      form,
      userID,
      updateUser,
      updateModal,
    };
  },
};
</script>

<style lang="scss">
.btn--add {
  background: #0a421f;
  color: white;
}

.modal--title {
  color: #0a421f;
}
</style>
